----------------------------------------------------------------------
-- chg_clk_pe
----------------------------------------------------------------------
-- Revision 00
-- Level	00
----------------------------------------------------------------------
-- File			: chg_clk_pe.vhd
-- Entity		: chg_clk_pe
-- Architecture	: RTL
-- Package		: gp
-- History -----------------------------------------------------------
-- Rev.Level	Date		Cause		Coded					Contents
-- 00.00		08/01/2011									new
----------------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity chg_clk_pe is
	port(
--<< ZbgNbN >>
		RST					: in	std_logic;						-- Zbg
		I_CLK				: in	std_logic;						-- ͐MpNbN
		O_CLK				: in	std_logic;						-- o͐MpNbN
--<< pXM >>
		p_iclk				: in	std_logic;						-- ̓pXCl[u
		p_oclk				: out	std_logic						-- o̓pX
	);
end chg_clk_pe;


architecture RTL of chg_clk_pe is

--------------------------------------------------
-- Components
--------------------------------------------------


--------------------------------------------------
-- Constants
--------------------------------------------------

--------------------------------------------------
-- Signals
--------------------------------------------------
signal	p_iclk_reg 			: std_logic;
signal	p_oclk_reg 			: std_logic;
signal	p_oclk_reg_s 		: std_logic_vector(7 downto 0);

begin

--########################################################################################
--	I_CLKO_CLKڂ
--########################################################################################
	-- pX]M
	process(I_CLK, RST)
	begin
		if (RST = '1') then
			p_iclk_reg <= '0';
		elsif (I_CLK'event and I_CLK = '1') then
			if (p_iclk = '1') then
				p_iclk_reg <= not p_iclk_reg;
			end if;
		end if;
	end process;
	-- O_CLKŃNbNڑւ
	process(O_CLK, RST)
	begin
		if (RST = '1') then
			p_oclk_reg <= '0';
		elsif (O_CLK'event and O_CLK = '1') then
			p_oclk_reg <= p_iclk_reg;
		end if;
	end process;
	process(O_CLK, RST)
	begin
		if (RST = '1') then
			p_oclk_reg_s <= (others => '0');
		elsif (O_CLK'event and O_CLK = '1') then
			p_oclk_reg_s <= p_oclk_reg_s(6 downto 0) & p_oclk_reg;
		end if;
	end process;

	p_oclk <= p_oclk_reg_s(1) xor p_oclk_reg_s(0);						-- o̓pX

end RTL;
