/*******************************************************************************

	Project        : PCI express

	Component      : sample app

	Module         : blockread.c

	Function       : block read sample

	Copyright (c) 2010 Skywave CO LTD.

-------------------------------------------------------------------------------
	[history]
	2010-09-27	Ver 1.00   M.Meguro    VK쐬

******************************************************************************/
//*******************************************/
//*    include								*/
//*******************************************/
#include	"PcieLib.h"

void
main(
	int		argc,
	char	*argv[]
)
{
	HANDLE	hDevice;
	int		ret;
	char	*stopstring;
	DWORD	bar;
	DWORD	offset;
	DWORD	size;
	BYTE	*buffer;
	FILE	*fp;

	if(argc!=5)
	{
		printf("Usage:\n");
		printf("\tblockread [address space] [offset] [size] [file]\n");
		printf("\taddress space:base address number\n");
		printf("\toffset:register offset\n");
		printf("\tsize:read bytes\n");
		printf("\tfile:save file name\n");
		exit(0);
	}
	hDevice=Pcie_OpenDevice(0);
	if(hDevice!=INVALID_HANDLE_VALUE)
	{
		bar=strtol(argv[1],&stopstring,0);
		offset=strtol(argv[2],&stopstring,0);
		size=strtol(argv[3],&stopstring,0);
		buffer=malloc(size);
		if(buffer)
		{
			ret=Pcie_ReadBlock(hDevice,bar,offset,size,buffer);
			if(ret!=PCIE_NORMAL)
				printf("Pcie_ReadBlock error=%d\n",ret);
			else
			{
				fopen_s(&fp,argv[4],"wb");
				if(fp)
				{
					fwrite(buffer,1,size,fp);
					fclose(fp);
				}
			}
			free(buffer);
		}
	}
	else
		printf("driver open error\n");
	if(hDevice!=INVALID_HANDLE_VALUE)
		Pcie_CloseDevice(hDevice);
}
