/*******************************************************************************

	Project        : PCI express

	Component      : sample app

	Module         : readreg.c

	Function       : read register

	Copyright (c) 2010 Skywave CO LTD.

-------------------------------------------------------------------------------
	[history]
	2010-09-27	Ver 1.00   M.Meguro    VK쐬

******************************************************************************/
//*******************************************/
//*    include								*/
//*******************************************/
#include	"PcieLib.h"

void
main(
	int		argc,
	char	*argv[]
)
{
	HANDLE	hDevice;
	int		ret;
	char	*stopstring;
	DWORD	bar;
	DWORD	offset;
	DWORD	type;
	DWORD	value;

	if(argc!=4)
	{
		printf("Usage:\n");
		printf("\treadreg [address space] [offset] [type]\n");
		printf("\taddress space:base address number\n");
		printf("\toffset:register offset\n");
		printf("\ttype:access type(0:32bit 1:16bit 2:8bit)\n");
		exit(0);
	}
	hDevice=Pcie_OpenDevice(0);
	if(hDevice!=INVALID_HANDLE_VALUE)
	{
		bar=strtol(argv[1],&stopstring,0);
		offset=strtol(argv[2],&stopstring,0);
		type=strtol(argv[3],&stopstring,0);
		if(type==1)
			ret=Pcie_ReadRegister16(hDevice,bar,offset,(WORD*)&value);
		else if(type==2)
			ret=Pcie_ReadRegister8(hDevice,bar,offset,(BYTE*)&value);
		else
			ret=Pcie_ReadRegister32(hDevice,bar,offset,&value);
		if(ret!=PCIE_NORMAL)
			printf("Pcie_ReadRegister error=%d\n",ret);
		else
			printf("0x%08X:0x%08X\n",atoi(argv[2]),value);
	}
	else
		printf("driver open error\n");
	if(hDevice!=INVALID_HANDLE_VALUE)
		Pcie_CloseDevice(hDevice);
}
