/*******************************************************************************

	Project        : PCI express

	Component      : sample app

	Module         : writepciconf.c

	Function       : write pci config

	Copyright (c) 2010 Skywave CO LTD.

-------------------------------------------------------------------------------
	[history]
	2010-09-27	Ver 1.00   M.Meguro    VK쐬

******************************************************************************/
//*******************************************/
//*    include								*/
//*******************************************/
#include	"PcieLib.h"

void
main(
	int		argc,
	char	*argv[]
)
{
	HANDLE	hDevice;
	int		ret;
	char	*stopstring;
	DWORD	size;
	DWORD	offset;
	DWORD	value;

	if(argc!=4)
	{
		printf("Usage:\n");
		printf("\twritepciconf [size] [offset] [value]\n");
		printf("\tsize:write size[MAX 4BYTE]\n");
		printf("\toffset:configuration area offset\n");
		printf("\tvalue:write value\n");
		exit(0);
	}
	hDevice=Pcie_OpenDevice(0);
	if(hDevice!=INVALID_HANDLE_VALUE)
	{
		size=strtol(argv[1],&stopstring,0);
		if(size>4)
		{
			printf("size is 4byte over\n");
			goto EXIT;
		}
		offset=strtol(argv[2],&stopstring,0);
		value=strtol(argv[3],&stopstring,0);
		ret=Pcie_WritePciConfig(hDevice,size,offset,&value);
		if(ret!=PCIE_NORMAL)
			printf("Pcie_WritePciConfig error=%d\n",ret);
	}
	else
		printf("driver open error\n");
EXIT:
	if(hDevice!=INVALID_HANDLE_VALUE)
		Pcie_CloseDevice(hDevice);
}
