/*******************************************************************************

	Project        : PCI express

	Component      : sample app

	Module         : writereg.c

	Function       : write register

	Copyright (c) 2010 Skywave CO LTD.

-------------------------------------------------------------------------------
	[history]
	2010-09-27	Ver 1.00   M.Meguro    VK쐬

******************************************************************************/
//*******************************************/
//*    include								*/
//*******************************************/
#include	"PcieLib.h"

void
main(
	int		argc,
	char	*argv[]
)
{
	HANDLE	hDevice;
	int		ret;
	char	*stopstring;
	DWORD	bar;
	DWORD	offset;
	DWORD	type;
	DWORD	value;

	if(argc!=5)
	{
		printf("Usage:\n");
		printf("\twritereg [address space] [offset] [value] [type]\n");
		printf("\taddress space:base address number\n");
		printf("\toffset:register offset\n");
		printf("\tvalue:write value\n");
		printf("\ttype:access type(0:32bit 1:16bit 2:8bit)\n");
		exit(0);
	}
	hDevice=Pcie_OpenDevice(0);
	if(hDevice!=INVALID_HANDLE_VALUE)
	{
		bar=strtol(argv[1],&stopstring,0);
		offset=strtol(argv[2],&stopstring,0);
		value=strtol(argv[3],&stopstring,0);
		type=strtol(argv[4],&stopstring,0);
		if(type==1)
			ret=Pcie_WriteRegister16(hDevice,bar,offset,(WORD)value);
		else if(type==2)
			ret=Pcie_WriteRegister8(hDevice,bar,offset,(BYTE)value);
		else
			ret=Pcie_WriteRegister32(hDevice,bar,offset,value);
		if(ret!=PCIE_NORMAL)
			printf("Pcie_WriteRegister error=%d\n",ret);
	}
	else
		printf("driver open error\n");
	if(hDevice!=INVALID_HANDLE_VALUE)
		Pcie_CloseDevice(hDevice);
}
